/*
 * Dinge die definiert werden mssen:
 *  
 *  baseValues: Namen
 *  
 *  coldef: Spalten fr die Gridansicht und Editmodus { 
 *  	renderfkt : null fr standard-renderer, ansonsten eigene FKT : Optional, nur Grid 
 *  	name : ID der Spalte,    
 *  	title : berschrift, 
 *  	description: Beschreibung des Wertes  : Tooltip
 *  	type : folgende Typen:
 *  		* string/null: String
 *          * integer: Zahl
 *          * trigger: 
 *          * action: 
 *          * message: Nachricht (Email)
 *  }
 *  
 * */

//https://10.0.35.100/json/property/query?query=/apartment/zones/*(ZoneID,isPresent,name)/groups/*(name,group)/scenes/*(scene,name)

var baseValues = {
	appId : 'event-mailer',
	editorTitle : 'Nachrichteigenschaft',
	newEntry : 'Neue Nachricht',
	editEntry : 'Nachricht bearbeiten',
	disableEntry : 'Benachrichtung abschalten',
	enableEntry : 'Benachrichtung anschalten',
	deleteEntry : 'Benachrichtigung l&ouml;schen'
};

function initValues() {
	login();
	initCaches();
}

function loadValueFunction() {
	// '/scripts/event-mailer/values/*(name,id,disabled)/*(zone,group,scene,messageType,receiver,subject,message)'
	var sString = ajaxSyncRequest(
			'/json/property/query',
			{
				'query' : '/scripts/event-mailer/values/*(name,id,disabled)/*(zone,group,scene,messageType,receiver,subject,message)'
			});
	var oServerObject = eval('(' + sString + ')');
	var oArray = [];
	for ( var iIndex = 0; iIndex < oServerObject.result.values.length; iIndex++) {
		var oSubObject = oServerObject.result.values[iIndex];
		var oObject = {};
		if (oSubObject.id != null)
			oObject.id = oSubObject.id;
		if (oSubObject.name != null)
			oObject.name = oSubObject.name;
		if (oSubObject.disabled != null)
			oObject.disabled = oSubObject.disabled;
		if (oSubObject[oSubObject.id] != null) {
			var oSubArray = oSubObject[oSubObject.id];
			for ( var jIndex = 0; jIndex < oSubArray.length; jIndex++) {
				var oSubSubObject = oSubArray[jIndex];
				if (oSubSubObject.messageType != null) {
					oObject.message = {};
					oObject.message.messageType = oSubSubObject.messageType;
					oObject.message.receiver = oSubSubObject.receiver;
					oObject.message.subject = oSubSubObject.subject;
					oObject.message.message = oSubSubObject.message;
				}
				if (oSubSubObject.zone != null) {
					oObject.trigger = {};
					oObject.trigger.zone = oSubSubObject.zone;
					oObject.trigger.group = oSubSubObject.group;
					oObject.trigger.scene = oSubSubObject.scene;
				}
			}
		}
		oArray.push(oObject);
	}
	fillAppDataStore(oArray);
}

function saveValueFunction(oValue) {
	var oPropsArray = [
			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/id',
				value : oValue.id,
				message : 'Speichere Daten'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/name',
				value : oValue.name,
				message : '"Namen" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/disabled',
				value : oValue.disabled,
				message : '"Aktiv" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/message/messageType',
				value : oValue.message.messageType,
				message : '"Nachrichtentyp" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/message/receiver',
				value : oValue.message.receiver,
				message : '"Empf&auml;nger" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/message/subject',
				value : oValue.message.subject,
				message : '"Betreff" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/message/message',
				value : oValue.message.message,
				message : '"Nachricht" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/trigger/zone',
				value : oValue.trigger.zone,
				message : '"Raum" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/trigger/group',
				value : oValue.trigger.group,
				message : '"Gruppe" speichern'
			},

			{
				path : '/scripts/' + baseValues.appId + '/values/' + oValue.id
						+ '/trigger/scene',
				value : oValue.trigger.scene,
				message : '"Aktivit&auml;t" speichern'
			}
	];
	var oSaveEvent={ name:baseValues.appId,parameter:{'actions' : 'save'},message:'Serialisieren anweisen' };

	bulkPropertySave(oPropsArray,oSaveEvent,loadValueFunction);
}

function deleteValueFunction(oValue) {
	removePropertySync('/scripts/' + baseValues.appId + '/values/' + oValue.id);
	loadValueFunction();
}

Ext.onReady(function() {
	initValues();
	initAppDataStore([ 'name', 'email', 'phone', 'id' ]);

	var colDef = [ {
		type : 'string',
		name : "name",
		title : "Name"
	}, {
		type : 'trigger',
		name : "trigger",
		title : "Ausl&ouml;ser"
	}, {
		type : 'message',
		name : "message",
		title : "Nachricht"
	} ];
	makeBasePanel(colDef, saveValueFunction, deleteValueFunction);
	loadValueFunction();
});
